// contact me at akaxeen.tyllo.de if you need help understanding the functions
var autosizerProgressListener = {
	QueryInterface: function(aIID) {
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
		  aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		  aIID.equals(Components.interfaces.nsISupports))
		  return this;
		throw Components.results.NS_NOINTERFACE;
	},
	onProgressChange: function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
	onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {},
	onSecurityChange: function(aWebProgress, aRequest, aState) {},
	onLinkIconAvailable: function(a) {},
	onStateChange: function (aWebProgress, aRequest, aStateFlags, aStatus) {},
	onLocationChange: function(aProgress, aRequest, aLocation) { if (aLocation) autosizer.genWidthCheck(false); }
}

function AutosizerPrefObserver() {
	autosizer.checkPrefs(false);
}

AutosizerPrefObserver.prototype = {
  observe: function(subject, topic, pref) {
		try { if (topic == 'nsPref:changed') autosizer.checkPrefs(false); } catch(e) {}
	}
};

var autosizer = {
	init: function() {  
		window.removeEventListener("load",function() { autosizer.init(); }, false);

		this.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBranch('browser.search.');

		this.initVar(); 		
		this.txtOld=document.getElementById("searchbar");
		this.tooltipwidth=0;
		
		if (this.prefs instanceof Components.interfaces.nsIPrefBranchInternal) {
			this.prefObserver = new AutosizerPrefObserver();
			this.prefs.addObserver('', this.prefObserver, false);
		}    

		this.getTooltipWidth(true);
		this.getNeededWidth();		
		
		if (!this.forceMacFix && this.useMacFix 
		     && (Components.classes['@mozilla.org/xre/app-info;1'])
		     && (Components.interfaces.nsIXULAppInfo) 
		     && (Components.interfaces.nsIXULRuntime))
		  this.sBox.setAttribute('platform',Components.classes['@mozilla.org/xre/app-info;1']
		    .getService(Components.interfaces.nsIXULAppInfo)
		    .QueryInterface(Components.interfaces.nsIXULRuntime).OS.toLowerCase()); 
		if(this.forceMacFix) this.sBox.setAttribute('platform','darwin'); 		
   
	 
	  var copyStyles=new Array('fontSize','fontSizeAdjust','fontStretch','fontStyle','fontVariant','fontWeight','letterSpacing','wordSpacing');
		var copyStyles2=new Array('font-size','font-size-adjust','font-stretch','font-style','font-variant','font-weight','letter-spacing','word-spacing');
		for(a in copyStyles) eval("this.label.style."+copyStyles[a]+"=document.defaultView.getComputedStyle(this.input, '').getPropertyValue('"+copyStyles2[a]+"');");

		window.addEventListener("load",function() { autosizer.genWidth(false); }, false);
		window.addEventListener("resize",function() { autosizer.genWidth(false); }, false);
		window.getBrowser().addProgressListener(autosizerProgressListener, Components.interfaces.nsIWebProgress.STATE_STOP);
		
		// Inject code instead of XBL binding 
		if(this.txt && "handleSearchCommand" in this.txt)
      eval("this.txt.handleSearchCommand ="+this.txt.handleSearchCommand.toString().replace(
      'textBox.value;',
      'textBox.value; if(autosizer.cleanOnSubmit) window.setTimeout("autosizer.clearSearchbar();",0); \ $&'
      )); 	
	}, 
	
	initVar: function() { 
		this.txt=document.getElementById("searchbar");
		this.sBox = document.getElementById("search-container");
		this.label=document.getElementById('autosizer-label'); 		
		this.input=this.txt._textbox;
	  
		// Everytime the interface is rebuilt (e.g. after customization) we need to remove it again. But we don't have to every time we set the variables and therefore we can save some cpu time :)
		if(this.input.hasAttribute('sizetopopup')) {
			this.input.removeAttribute('sizetopopup'); // Removing this allows the popup to be sized in width. 
			// Again inserting code. This forces all autocomplete popups to be at least puMinWidth in width, however most popups size to their owner and therefore this doesn't take effect. It needs to be set
			var puMinWidth=this.prefs.getIntPref('autocompletePopupMinWidth');
			if(this.input && "openPopup" in this.input)
				eval("this.input.openPopup ="+this.input.openPopup.toString().replace(
					'this.boxObject.width',
					'(this.boxObject.width<'+puMinWidth+'?'+puMinWidth+':this.boxObject.width)'
					));
		}
		
		this.input=document.getAnonymousElementByAttribute(this.input, "anonid", "textbox-input-box"); 
		this.input.onCommand="autosizer.genWidthCheck(event);";
		this.input.onCommand="autosizer.genWidthCheck(event);";
		this.diffWidth=(1+this.sBox.boxObject.width)-this.input.boxObject.width;  		  
		this.sBox.flex=0;   
},
	
	checkPrefs: function() {   
    this.useMacFix=this.prefs.getBoolPref('useMacFix');
    this.forceMacFix=this.prefs.getBoolPref('forceMacFix');
    this.offset=this.prefs.getIntPref('offset');
		this.labelOffset=this.prefs.getIntPref('labelOffset');
	  this.minwidth=this.prefs.getIntPref('minwidth');
		this.maxwidth=this.prefs.getIntPref('maxwidth');
		this.cleanOnSubmit=this.prefs.getBoolPref('cleanOnSubmit');
		
		
		// For the wizard only
		this.manualResize=this.prefs.getCharPref('manualResize'); 
		
		document.getElementById('autosizer-size-right').hidden=(this.manualResize.length?false:true);
    document.getElementById('autosizer-size-left').hidden=(this.manualResize.length?false:true);
		if(this.manualResize.length && !this.dragging) {
		  this.txt.value='';	
		
			if(this.manualResize=='max') this.sBox.width=(window.outerWidth-autosizer.neededWidth);
			else if(this.manualResize=='label') this.sBox.width=this.tooltipwidth;
			else if(this.manualResize=='nosize') {}
			else this.sBox.width=this.manualResize;
			this.moveGrippys();
			this.flashGrippys(10);
		}		
		// Wizard part end
		
		setTimeout("autosizer.getTooltipWidth(false);autosizer.genWidth(false);",0);
	},
	
	getNeededWidth: function() { 
		var toolbaritems=this.sBox.parentNode.childNodes,flextemp,i,x;
		this.neededWidth=0;
		for(i=0;x=toolbaritems[i];i++) {
			if(x.id=='search-container') continue;
			flextemp=x.getAttribute('flex');
			x.setAttribute('flex',0);
			this.neededWidth+=toolbaritems[i].boxObject.width;
			x.setAttribute('flex',flextemp);
		}
	}, 	

	genWidth: function(evt) {
		if(this.manualResize.length) return; // When sizing manually, we don't want any events to break this
	  if(evt && evt.keyCode!=40 && evt.keyCode!=33 && evt.keyCode!=38 && evt.keyCode!=34 && this.txt.value.length>this.label.value.length+1) window.setTimeout("autosizer.focusEnd();",0); // on insertion fix - avoid if items were inserted by autocomplete	 			
    
    var availableWidth=window.outerWidth-this.neededWidth;     
    if(this.txt.getAttribute('empty')=='true') 
      this.label.value=''; // Avoid autosizing to search engine description if minwidth!=0
    else
    	this.label.value=this.txt.value;     
	  var width=this.label.boxObject.width+this.diffWidth+this.offset+9; // +9 explaination: If you type something in the searchbox, it is too narrow and moves the query to the left to display the just typed in letter. Once this is done, autosizer resizes the searchbar to its needed width. However, the text does not realign automatically. Therefore Autosizer would have to do so (like it does for the on insertion fix) but this procedure is quite slow which makes the typing look laggy. To prevent this, I just add 9 pixels to give enough space for the next letter. When done so, the searchbar is wide enough and it doesn't move the text. If 9 pixels is too less for your theme/language increase the "offset".
		if(width>this.maxwidth && this.maxwidth>0) width=this.maxwidth; // set max width 
		if(width<this.minwidth && this.minwidth>0) width=this.minwidth; // set min width
		if((this.txt.getAttribute('empty')=='true' || this.txt.value.length==0 || width<this.tooltipwidth) && this.tooltipwidth>0 && this.minwidth==0)
		  width=this.tooltipwidth+this.labelOffset; // set tooltip width (grey text)
		if(width>availableWidth && availableWidth>0) width=availableWidth; // available width
		if(width<this.diffWidth) width=this.diffWidth; // needed width	
    autosizer.sBox.width=width; 
  
	},
	
	focusEnd: function() { 
	  // This method only works when the searchabr isn't yet at its max-width
	  selStart=autosizer.txt._textbox.selectionEnd; // Save cursor position

		temp=autosizer.txt.value; // Save current value
		autosizer.txt.value+=' '; // Just add a space/letter in the end to force the searchbar to realign the text after resizing (cursor is moved here)
		autosizer.txt.value=temp; // remove the space again		
		
		// Focuses the end even if the searchbar is at its max-width
		if(selStart==autosizer.txt._textbox.textLength) {
			var oEvent = document.createEvent('KeyEvents');  
			oEvent.initKeyEvent("keypress",true,true,null,false,false,false,false,oEvent.DOM_VK_END ,0);
		  autosizer.input.dispatchEvent(oEvent);
		} else autosizer.txt._textbox.setSelectionRange(selStart,selStart);
		
		// Unfortunately I don't know a way to focus the correct position if the searchbar is at its max-width if the text wasn't inserted at the end
	}, 
	
	getTooltipWidth: function(canSkip) {
	   this.diffWidth=(1+this.sBox.boxObject.width)-this.input.boxObject.width;
		 if(this.minwidth>0 && canSkip) {
		 	 this.tooltipwidth=0;
		 	 return;
		 }
		 var temp=this.label.value;   
     this.label.value=this.txt.currentEngine.name;
     this.tooltipwidth=this.label.boxObject.width+this.diffWidth; 
     this.label.value=temp; 
	},     	

	genWidthCheck: function(evt) {
		this.initVar();     
		if(this.manualResize.length) return; // When sizing manually, we don't want any events to break this
		if(this.txtOld!=this.txt) {
			this.txtOld=document.getElementById("searchbar");
			this.getNeededWidth();
		}  
		
		if(this.label.value!=this.txt.value) this.genWidth(evt);
	},  
	
	clearSearchbar: function() {
	  this.txt.value='';
	  this.txt.empty=true;
		var inputEvent = document.createEvent('Events');
		if (inputEvent) {
		  inputEvent.initEvent('oninput', true, true);
		  this.txt.dispatchEvent(inputEvent);
	  } 
	  this.genWidthCheck();
	},

	d: function(t) {
   Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage('autosizer: '+t);
	},
	
	// MANUAL RESIZING FUNCTION, thanks to resize search box
  startDrag: function(aEvent, ltr) {
	  const a=autosizer;
    if(aEvent.button == 0) {
      a.startX = aEvent.clientX;
      a.startY = aEvent.clientY;
      a.dragging = true;
      a.ltr = ltr;
						
      a.sLen = a.sBox.width;  //store original width for calculations

      window.addEventListener("mousemove", a.whileDrag, true);
      window.addEventListener("mouseup", a.endDrag, true);
    }
  },

  whileDrag: function(aEvent) {
	  const a=autosizer;
    if(a.dragging) {
      var dX = aEvent.clientX - a.startX;
      var dY = aEvent.clientY - a.startY;

      //If the pointer wanders too far while dragging
      //we will assume it was an accidental drag and abort.
      if(Math.abs(dY) > 140) {
        a.clearDrag(true);
        return;
      }

      if(!a.ltr) dX *= -1;

      if(a.sLen - dX > a.diffWidth && a.sLen - dX < window.outerWidth-a.neededWidth) {
        a.sBox.width = a.sLen - dX;
				if(a.sBox.boxObject.width!=autosizer.sBox.width) {
				  a.sBox.width=a.sBox.boxObject.width;
					a.diffWidth=a.sBox.width;
				}
				a.moveGrippys();
				a.saveDrag();
      }
    } else a.clearDrag(true);
  },

  endDrag: function(aEvent) {
    autosizer.clearDrag(false);
    autosizer.saveDrag();
  },

  clearDrag: function(revert) {
	  const a=autosizer; 
    a.dragging = false;
    window.removeEventListener("mousemove", a.whileDrag, true);
    window.removeEventListener("mouseup", a.endDrag, true);

    if(revert) {
		  a.sBox.width = a.sLen;
			this.moveGrippys();
		}
  },
	
	saveDrag: function() {
	  const a=autosizer;
		// This pref is used to send the information back to the wizard dialog. Apart from the new width it contains comparison values so that the wizard can make usefull suggestions ("do you want to size it to the label automatically?" instead of just measuring the width)
	  a.prefs.setCharPref("autosizerwizard", a.sBox.width+'|'+a.diffWidth+'|'+a.tooltipwidth+'|'+(window.outerWidth-a.neededWidth));
	},
	
	moveGrippys: function() {
	  const a=autosizer.sBox.boxObject;
		const t=autosizer.txt.boxObject;
	  var r=document.getElementById('autosizer-size-right');
	  var l=document.getElementById('autosizer-size-left');

	  l.style.left=a.x+'px';
	  l.style.height=(t.height-4)+'px';
	  l.style.top=t.y+'px';
		
		r.style.left=(a.x+a.width-(2+r.boxObject.width))+'px';
		r.style.height=(t.height-4)+'px';
	  r.style.top=(t.y)+'px';
	},
	
	flashGrippys: function(num) {
	  var r=document.getElementById('autosizer-size-right');
	  var l=document.getElementById('autosizer-size-left');
	  if(num%2==0) {
		  r.setAttribute('class','autosizer-grippy autosizer-grippy-flash1');
		  l.setAttribute('class','autosizer-grippy autosizer-grippy-flash1');
		} else {
		  r.setAttribute('class','autosizer-grippy autosizer-grippy-flash2');
		  l.setAttribute('class','autosizer-grippy autosizer-grippy-flash2');
		}
		if(num>0) window.setTimeout("autosizer.flashGrippys("+(num-1)+");",300);
		else {
			r.setAttribute('class','autosizer-grippy ');
		  l.setAttribute('class','autosizer-grippy');
		}
	}
}

window.addEventListener("load",function() { autosizer.init(); }, false);